# -*- coding:Utf-8 -*-

import es
from redirectlib import Redirect
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "redirect"
info.version = "1.0"
info.author = "EmbouT"
info.url = "http://mattie.info/forums/"
info.description = "Fourni une commande pour rediriger un joueur sur un autre serveur. Mot de passe pris en charge"



def load():
    if not es.exists('command','redirect'):
        es.regcmd('redirect','redirect_cmd','Commende pour rediriger un joueur sur un autre serveur. Syntax : redirect <userid/"nom du joueur"/"Steam ID"> <"ip:port"> ["mot de passe"] [kick] [delai]')


def redirect_cmd():
    argc = es.getargc()
    if argc in (3,4,5,6):
        player=es.getargv(1)
        userid=es.getuserid(player)
        if userid:
            server=es.getargv(2)
            password=''
            kick='0'
            delay=''
            if argc>3:
                password = es.getargv(3)
                if argc>4:
                    kick=es.getargv(4)
                    if argc==6:
                        delay=es.getargv(5)
            Redirect(server,password,kick,delay).send(userid)
        else:
            es.dbgmsg(0,'[redirect] Erreur : joueur "%s" non trouvé'%player)
    else:
        es.dbgmsg(0,'[redirect] Erreur de syntaxe !!')
        es.dbgmsg(0,'[redirect] Syntaxe : redirect <userid/"nom du joueur"/"Steam ID"> <"ip:port"> ["mot de passe"] [kick] [delai]')





