# -*- coding:Utf-8 -*-
import es
import gamethread
import popuplib
import playerlib
from random import Random
from redirectlib import Redirect
import psyco
psyco.full()
from es import server_var

info = es.AddonInfo()
info.name = "redirection"
info.version = "1.0"
info.author = "EmbouT"
info.url = "http://mattie.info/forums/"
info.description = "Redirige un joueur sur un autre serveur"

saycmd=es.ServerVar('redirection_saycmd')
menukick=es.ServerVar('redirection_menukick')
maxplayers=es.ServerVar('redirection_maxplayers')
reserveslot=es.ServerVar('redirection_reserveslot')
hazard=es.ServerVar('redirection_random')
sendmenu=es.ServerVar('redirection_sendmenu')
forceredirect=es.ServerVar('redirection_forceredirect')
kick=es.ServerVar('redirection_kick')
temps=es.ServerVar('redirection_time')
menuselect=es.ServerVar('redirection_menuselect')
admin=server_var.getObject('BASIC_AUTH_ADMIN_LIST')

servergroup={}
plist=[]


def load():
    if not es.exists('command','serveradd'):
        es.regcmd('serveradd','redirection/serveradd_cmd',"Commande d'ajout de serveur de redirection. Syntaxe : serveradd <ip:port> [mot de passe] [nom du serveur]")
    es.mexec('../addons/eventscripts/redirection/redirection.cfg')
    gamethread.delayed(0.2,createcmd_say)

def createcmd_say():
    if not str(saycmd) == '0':
        if not es.exists('saycommand',str(saycmd)):
            es.regsaycmd(str(saycmd),'redirection/say_cmd',"Commande tchat personnalisée pour l'appel du menu de redirection")

def serveradd_cmd():
    argc=es.getargc()
    if argc>1 or argc<5:
        server=es.getargv(1)
        name=es.getargv(1)
        password=''
        if argc>2:
            password=es.getargv(2)
            if password=='0':password=''
            if argc==4:
                name=es.getargv(3)
                if name=='0':name=server
        servergroup[len(servergroup)]={'server':server,'password':password,'name':name}
        if not str(saycmd)=='0' or not str(sendmenu)=='0':
            createmenu()

    else:
        es.dbgmsg(0,'[redirection] Erreur de syntaxe !')
        es.dbgmsg(0,'[redirection] Syntaxe : serveradd <ip:port> ["mot de passe"] ["nom du serveur"]')

def say_cmd():
    userid=es.getcmduserid()
    if servergroup:
        popuplib.send('redirection_server_menu_page_1',userid)
        es.playsound(userid,"buttons/combine_button7.wav", 1.0)
    else:
        es.tell(userid,'#multi',"#green [redirection] #default Il n'y a aucun serveur de redirection")

def createmenu():
    spp=0
    spc=0
    m=0
    menu={}
    for s in servergroup:
        if spp==5:spp=0
        if spp==0:
            spc+=1
            if spc>1:
                menu[m].addline('-------------------------------')
                menu[m].addline('->8. Page précédente')
                menu[m].addline('->9. Page suivante')
                menu[m].addline('0. Quitter')
                spc-=2
                menu[m].submenu(8,'redirection_server_menu_page_%i'%spc)
                spc+=2
                menu[m].submenu(9,'redirection_server_menu_page_%i'%spc)
                menu[m].enablekeys=mek+'89'
                menu[m].menuselect=menu_select
            if popuplib.exists('redirection_server_menu_page_%i'%spc):popuplib.delete('redirection_server_menu_page_%i'%spc)
            m+=1
            mek='0'
            menu[m]=popuplib.create('redirection_server_menu_page_%i'%spc)
            menu[m].addline('Choisis un serveur de redirection')
            menu[m].addline('-------------------------------')
        spp+=1
        mek+=str(spp)
        menu[m].addline('->%i. %s'%(spp,servergroup[s]['name']))
        menu[m].menuvalue('redirection_menuselect',spp,s)

    if spc>1:
        menu[m].addline('-------------------------------')
        menu[m].addline('->8. Page précédente')
        menu[m].addline('->9. 1ère page')
        menu[m].addline('0. Quitter')
        spc-=1
        menu[m].submenu(8,'redirection_server_menu_page_%i'%spc)
        spc+=1
        menu[m].submenu(9,'redirection_server_menu_page_1')
        menu[m].enablekeys=mek+'89'
        menu[m].menuselect=menu_select
        menu[1].modline(9,'->8. Dernière page')
        menu[1].submenu(8,'redirection_server_menu_page_%i'%spc)
        i=1
        while i <= spc:
            menu[i].modline(1,'Choisis un serveur de redirection : page%i/%i'%(i,spc))
            i+=1
    elif spc==1:
        menu[1].addline('-------------------------------')
        menu[1].addline('0. Quitter')
        menu[1].enablekeys=mek
        menu[1].menuselect=menu_select

def menu_select(userid,choix,menuname):
    if choix<10:
        es.playsound(userid,"buttons/button14.wav", 1.0)
        if choix<6:
            redirectplayer(userid,int(menuselect),1)
            gamethread.cancelDelayed('redirectionforce%s'%userid)
    else:
        es.playsound(userid,"buttons/combine_button7.wav", 1.0)

def redirectplayer(userid,s,m=0):
    k=int(kick)
    if m:k=int(menukick)
    Redirect(servergroup[s]['server'],servergroup[s]['password'],k,float(temps)).send(userid)


def redirectforce(userid):
    p=popuplib.active(userid)
    if p['name']:
        popuplib.close(p['name'],userid)
        redirectplayer(userid,Random().randint(0,len(servergroup)-1)if int(hazard) else 0)

def player_activate(event_var):
    if servergroup:
        userid=event_var['userid']
        if maxplayers<es.getplayercount():
            a=0
            if int(reserveslot):
                if event_var['es_steamid']in str(admin).split(';'):
                    lastplayer=foundlastplayer(userid)
                    a=1 if lastplayer == userid else 2
                    userid=lastplayer
            if int(sendmenu):
                popuplib.send('redirection_server_menu_page_1',userid)
                gamethread.delayedname(int(forceredirect),'redirectionforce%s'%userid,redirectforce,userid)
            else:
                redirectplayer(userid,Random().randint(0,len(servergroup)-1)if int(hazard) else 0)
            if a==2:
                es.tell(userid,'#multi',"#green [redirection] #default Un admin vient d'arriver")
                es.tell(userid,'#multi',"#green [redirection] #default Tu dois lui laisser ta place !!")
            elif a==1:
                es.tell(userid,'#multi',"#green [redirection] #default Il n'y a que des admins sur le serveur !!")
            else:
                es.tell(userid,'#multi',"#green [redirection] #default Le serveur est plein !!")
        elif int(reserveslot):
            if not event_var['es_steamid']in str(admin).split(';'):
                plist.append(userid)

def foundlastplayer(user):
    if plist:
        userid=plist.pop()
        if not es.exists('userid',userid):
            foundlastplayer(user)
        else: return userid
    else:
        return user

def player_disconnect(event_var):
    if servergroup:
        if event_var['userid'] in plist:
            plist.remove(event_var['userid'])
        gamethread.cancelDelayed('redirectionforce%s'%event_var['userid'])

def unload():
    if es.exists('saycommand',str(saycmd)):
        es.unregsaycmd(str(saycmd))
    i=1
    while i > 0:
        if popuplib.exists('redirection_server_menu_page_%i'%i):
            popuplib.delete('redirection_server_menu_page_%i'%i)
            i+=1
        else : i=0
